# Makefile for static bzlib-mini for GNU targets

INCLUDEDIR = $(BZLIBDIR)/include
OBJECTDIR = $(BZLIBDIR)/objects
LIBDIR = $(BZLIBDIR)
SRCDIR = $(BZLIBDIR)/src

OBJECTS = $(OBJECTDIR)/blocksort.o $(OBJECTDIR)/bzlib.o $(OBJECTDIR)/compress.o $(OBJECTDIR)/crctable.o $(OBJECTDIR)/decompress.o $(OBJECTDIR)/huffman.o $(OBJECTDIR)/randtable.o

LIBNAME = $(LIBDIR)/libbz2-mini.a

COMPILER = gcc
LINKER = ar
REMOVER = rm
ECHO = echo
COMPILER_OPTS = -I$(INCLUDEDIR) -march=i586 -O6 -ffast-math -Wall -fno-exceptions -c
LINKER_OPTS = r $(LIBNAME)
REMOVER_OPTS = -f

.PHONY: all install clean
.SILENT:

all: $(OBJECTS) $(LIBNAME)

install:

clean:
	$(ECHO) -n Cleaning directories...
	$(REMOVER) $(REMOVER_OPTS) $(OBJECTS) $(LIBNAME)
	$(ECHO) done.

$(LIBNAME): $(OBJECTS)
	$(ECHO) -n Linking $(LIBNAME)...
	$(LINKER) $(LINKER_OPTS) $(OBJECTS)
	$(ECHO) done.

$(OBJECTDIR)/blocksort.o: $(SRCDIR)/blocksort.c
	$(ECHO) -n Compiling $(SRCDIR)/blocksort.c...
	$(COMPILER) $(COMPILER_OPTS) $(SRCDIR)/blocksort.c -o $(OBJECTDIR)/blocksort.o
	$(ECHO) done.

$(OBJECTDIR)/bzlib.o: $(SRCDIR)/bzlib.c
	$(ECHO) -n Compiling $(SRCDIR)/bzlib.c...
	$(COMPILER) $(COMPILER_OPTS) $(SRCDIR)/bzlib.c -o $(OBJECTDIR)/bzlib.o
	$(ECHO) done.

$(OBJECTDIR)/compress.o: $(SRCDIR)/compress.c
	$(ECHO) -n Compiling $(SRCDIR)/compress.c...
	$(COMPILER) $(COMPILER_OPTS) $(SRCDIR)/compress.c -o $(OBJECTDIR)/compress.o
	$(ECHO) done.

$(OBJECTDIR)/crctable.o: $(SRCDIR)/crctable.c
	$(ECHO) -n Compiling $(SRCDIR)/crctable.c...
	$(COMPILER) $(COMPILER_OPTS) $(SRCDIR)/crctable.c -o $(OBJECTDIR)/crctable.o
	$(ECHO) done.

$(OBJECTDIR)/decompress.o: $(SRCDIR)/decompress.c
	$(ECHO) -n Compiling $(SRCDIR)/decompress.c...
	$(COMPILER) $(COMPILER_OPTS) $(SRCDIR)/decompress.c -o $(OBJECTDIR)/decompress.o
	$(ECHO) done.

$(OBJECTDIR)/huffman.o: $(SRCDIR)/huffman.c
	$(ECHO) -n Compiling $(SRCDIR)/huffman.c...
	$(COMPILER) $(COMPILER_OPTS) $(SRCDIR)/huffman.c -o $(OBJECTDIR)/huffman.o
	$(ECHO) done.

$(OBJECTDIR)/randtable.o: $(SRCDIR)/randtable.c
	$(ECHO) -n Compiling $(SRCDIR)/randtable.c...
	$(COMPILER) $(COMPILER_OPTS) $(SRCDIR)/randtable.c -o $(OBJECTDIR)/randtable.o
	$(ECHO) done.
