 /* IOLib-Filters-C, Filter package for IOLib-C
  * Copyright (C) 1998-2001 Robert Kausch <robert.kausch@gmx.net>
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Library General Public
  * License as published by the Free Software Foundation; either
  * version 2 of the License, or (at your option) any later version.
  *
  * This library is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  * Library General Public License for more details.
  *
  * You should have received a copy of the GNU Library General Public
  * License along with this library; if not, write to the Free
  * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  * MA 02111-1307, USA */

#ifndef _H_IOLIB_FILTERS_XOR_
#define _H_IOLIB_FILTERS_XOR_

#include <iolib-c.h>
#include "iolib-filters-c.h"

#define FilterXOR_New(x)	x=malloc(sizeof(FilterXOR));FilterXOR_Init_real(x);
#define FilterXOR_Free(x)	FilterXOR_Free_real(x);free(x);

typedef struct _FilterXOR
{
	int		 modifier;
	IOLibFilter	*filter;
} FilterXOR;

#ifdef __WIN32__
#ifdef IOLIB_FILTERS_DLL
	__declspec (dllexport)
#endif
#endif

void FilterXOR_Init_real(FilterXOR *);

#ifdef __WIN32__
#ifdef IOLIB_FILTERS_DLL
	__declspec (dllexport)
#endif
#endif

void FilterXOR_Free_real(FilterXOR *);

void FilterXOR_EncodeProc(IOLibFilter *, unsigned char **, int, int *, void *);
void FilterXOR_DecodeProc(IOLibFilter *, unsigned char **, int, int *, void *);

#ifdef __WIN32__
#ifdef IOLIB_FILTERS_DLL
	__declspec (dllexport)
#endif
#endif

void FilterXOR_SetModifier(FilterXOR *, int);

#ifdef __WIN32__
#ifdef IOLIB_FILTERS_DLL
	__declspec (dllexport)
#endif
#endif

IOLibFilter *FilterXOR_GetFilter(FilterXOR *);

#endif
