#include <iolib-c.h>
#include <iolib-filters-c.h>

int main()
{
	OutStream	*console;
	OutStream	*out;
	FilterXOR	*filter_xor;
	InStream	*in;
	int		 i;

	OutStream_New(console);
	OutStream_Connect(console, STREAM_ANSI, stdout);

	OutStream_New(out);
	OutStream_Connect(out, STREAM_FILE, "test.out", OS_OVERWRITE);

	FilterXOR_New(filter_xor);
	FilterXOR_SetModifier(filter_xor, 2135456343);

	OutStream_SetFilter(out, FilterXOR_GetFilter(filter_xor));

	OutStream_OutputString(console, "Writing \'This is a test for the new IOLib-Filters library!\' 100 times...");

	for (i = 0; i < 100; i++)
	{
		OutStream_OutputString(out, "This is a test for the new IOLib-Filters library!\n");
	}

	OutStream_OutputString(console, "done.\n");

	OutStream_RemoveFilter(out);

	OutStream_Free(out);

	InStream_New(in);
	InStream_Connect(in, STREAM_FILE, "test.out");

	InStream_SetFilter(in, FilterXOR_GetFilter(filter_xor));

	OutStream_OutputString(console, "Reading from the file again:\n");

	for (i = 0; i < 49; i++)
	{
		InStream_InputString(in, 50);
	}

	OutStream_OutputString(console, InStream_InputString(in, 50));

	for (i = 0; i < 49; i++)
	{
		InStream_InputString(in, 50);
	}

	OutStream_OutputString(console, InStream_InputString(in, 50));

	InStream_RemoveFilter(in);

	InStream_Free(in);
	FilterXOR_Free(filter_xor);
	OutStream_Free(console);

	return 0;
}
